package com.sun.org.apache.xalan.internal.xsltc.compiler;

import com.sun.org.apache.bcel.internal.generic.GOTO;
import com.sun.org.apache.bcel.internal.generic.InstructionList;
import com.sun.org.apache.bcel.internal.generic.ConstantPoolGen;
import com.sun.org.apache.bcel.internal.generic.PUSH;
import com.sun.org.apache.xalan.internal.xsltc.compiler.util.MethodGenerator;
import com.sun.org.apache.xalan.internal.xsltc.compiler.util.ClassGenerator;
import com.sun.org.apache.xalan.internal.xsltc.compiler.util.TypeCheckError;
import com.sun.org.apache.xalan.internal.xsltc.compiler.util.Type;

final class BooleanExpr extends Expression
{
    private boolean _value;
    
    public BooleanExpr(boolean value) {
        this._value = value;
    }
    
    @Override
    public Type typeCheck(SymbolTable stable) throws TypeCheckError {
        return this._type = Type.Boolean;
    }
    
    @Override
    public String toString() {
        return this._value ? "true()" : "false()";
    }
    
    public boolean getValue() {
        return this._value;
    }
    
    public boolean contextDependent() {
        return false;
    }
    
    @Override
    public void translate(ClassGenerator classGen, MethodGenerator methodGen) {
        ConstantPoolGen cpg = classGen.getConstantPool();
        InstructionList il = methodGen.getInstructionList();
        il.append(new PUSH(cpg, this._value));
    }
    
    @Override
    public void translateDesynthesized(ClassGenerator classGen, MethodGenerator methodGen) {
        InstructionList il = methodGen.getInstructionList();
        if (this._value) {
            il.append(BooleanExpr.NOP);
        }
        else {
            this._falseList.add(il.append(new GOTO(null)));
        }
    }
}
